Lines To Polygons, Polygonize and Refactor Fields change all attributes to string 255
Status: Closed

Priority: High

Assignee:

Category: Attribute table

Affected QGIS version:2.18.13 Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 25164

Description

On my two Windows 10 systems running QGIS Desktop 2.18 for Windows 64-bit, output attribute tables produced by the Lines To

Polygons tool and Polygonize tool differ from the input table of the source layer. All fields in the output table are type string, length 255.

Same problem occurs with Refactor Fields tool.

The problem appears to be new in QGIS Desktop 2.18. I found it in 2.18.12. Then upgraded to 2.18.13 with same problem results. I next

downloaded and installed QGIS 2.14.19 and ran same test. Results are as desired and expected: output layer attribute table is same as

input layer.

I reported this problem in two Stack Exchange posts but received no answers:

    -  https://gis.stackexchange.com/questions/256373/lines-to-polygons-and-polygonize-attribute-table-problem

    -  https://gis.stackexchange.com/questions/254830/qgis-refactor-fields-unwanted-behavior

History

#1 - 2017-10-10 09:34 AM - Giovanni Manghi

- Operating System deleted (Windows)

- Subject changed from Lines To Polygons and Polygonize attribute table problem to Lines To Polygons, Polygonize and Refactor Fields change all 

attributes to string 255

- Priority changed from Normal to High

- Regression? changed from No to Yes

#2 - 2017-10-16 02:10 PM - Giovanni Manghi

- Resolution set to fixed/implemented

- Status changed from Open to Closed

Fixed in commit:3dfe1b35ef5a082591aa9d99e15b25d0164ca312

and commit:135aea5ef8929991b36e455bd87e6df153e7d17d

please give the patches a try to confirm is now ok.

#3 - 2017-10-31 03:36 AM - John  Browne

- Status changed from Closed to Reopened

My test finds that the problem persists in QGIS Desktop 2.18.14 for Windows 64-bit, which includes two patches. Hoping others have tested.

#4 - 2017-11-02 12:54 PM - Giovanni Manghi
https://gis.stackexchange.com/questions/256373/lines-to-polygons-and-polygonize-attribute-table-problem
https://gis.stackexchange.com/questions/254830/qgis-refactor-fields-unwanted-behavior


- Resolution deleted (fixed/implemented)

- Status changed from Reopened to Feedback

John  Browne wrote:

My test finds that the problem persists in QGIS Desktop 2.18.14 for Windows 64-bit, which includes two patches. Hoping others have tested.

I just tested again and it seems ok to me. Do you have a "processing" folder in ~/.qgis2/python/plugins?

Also if you still see this add data and exact steps to replicate.

#5 - 2017-11-03 08:46 PM - John  Browne

- File service_districts_shape.zip added

- File screen Capture.JPG added

Thank you for pursuing this. My installation's "processing" folder location is C:\Program Files\QGIS 2.18\apps\qgis\python\plugins\processing. Two files

are attached from testing again today with the QGIS 2.18.14 Polygons-to-Lines tool:

    -  data source: a fresh download of local Fauquier County, VA service_districts_shape.zip polygon file

    -  screen capture.jpg of the layer properties/fields tables in the test results. Top is the source layer input table, middle is the resulting output table, bottom

is output table from second test with QGIS 2.14.20

Results:

    -  The middle table (output) differs from the top (input) table in both field Length and Precision, and changes Type "qlonglong" to "int". 

    -  The bottom table (output using QGIS 2.14.20) exactly matches the top (input) table.

I understand QGIS 2.14 uses the fTools plugin, whereas QGIS 2.18 performs this work with the Processing plugin and fTools is no longer available.

I tested with Polygons-to-Lines tool rather than Lines-to-Polygons tool in order to use a known, tested, publicly available file. My earlier tests used locally

developed shape line files. The results of today's test produce the same problems in the output attribute table as in earlier tests.

#6 - 2017-11-03 09:30 PM - Giovanni Manghi

    -  The middle table (output) differs from the top (input) table in both field Length and Precision, and changes Type "qlonglong" to "int".

isn't qlonglong an integer?

#7 - 2017-11-07 04:39 AM - John  Browne

I lack expertise to judge, but Internet search indicates qlonglong is integer (apparently integer 64 in Windows). My concern is ability to join and otherwise

use output tables with other layers. If feature type names and lengths differ, problems may occur. Again, thank you for working on this.

#8 - 2017-11-07 02:35 PM - Giovanni Manghi

John  Browne wrote:

My concern is ability to join and otherwise use output tables with other layers. If feature type names and lengths differ, problems may occur. Again,

thank you for working on this.
do you have any evidence that a such field cannot be used for a join or does not show as input/parameter in some qgis tool?

#9 - 2017-11-08 03:35 AM - John  Browne

Several tests today in QGIS show no problem joining Polygons-to_Lines output tables to other layers or joining an imported Excel table to the output table.

I no longer have concern in this regard.

#10 - 2017-11-08 02:30 PM - Giovanni Manghi

- Resolution set to fixed/implemented

- Status changed from Feedback to Closed

Files

service_districts_shape.zip 40.8 KB 2017-11-03 John  Browne

screen Capture.JPG 142 KB 2017-11-03 John  Browne
